/*////////////////////////////////////////////////////////////////////////////////////////////////
//                                         ///////////////////////////////////////////////////////
//    App                                  ///////////////////////////////////////////////////////
//                                         ///////////////////////////////////////////////////////
//    File:    app.js                      ///////////////////////////////////////////////////////
//    Date:    3/05/2013                   ///////////////////////////////////////////////////////
//                                         ///////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////*/


var layout = (function(){
	
	var items = [];
	var views = {};
	var currentView;
	
	var reset = function () {
		for (var i=0; i < items.length; i++) {
			var item = items[i];
			$(item.el).offset(item.offset);
      if (item.width) { $(item.el).width(item.width); } // computed width not set until image is loaded
      if (item.height) { $(item.el).height(item.height); } // computed height not set until image is loaded
			$(item.el)[0].style.opacity = item.opacity;
		}
	}
		
	return {
		
		transitionSpeed: 1,
		
		init: function (selectors, baseViewId, currentViewId) {
			
			// Find all the layout items
			for (var i=0; i < selectors.length; i++) {
				
				var el = $(selectors[i])[0];
				
				// copy their state
				var item = {};
					item.el = el;
					item.offset = $(el).offset();
					item.width = $(el).width();
					item.height = $(el).height();
					item.opacity = el.style.opacity;
					
				// and store them
				items.push(item);
				
			};
			
			// Find all the containing views
			$("section").each(function () {
				var view = {};
					view.el = this;
					view.id = $(this).attr("id");
				
				// hide currently unneeded views
				if (view.id !== baseViewId && view.id !== currentViewId) {
					$(view.el).hide();
				}
				
				// set baseView
				if (view.id === baseViewId) {
					baseView = view;
				}
				
				// set currentView
				if (view.id === currentViewId) {
					currentView = view;
				}
				
				// and store them
				views[view.id] = view;
			});
		},
		transitionTo: function (id, startTimeline) {
			
			if (id !== currentView.id) {

				$(views[id].el).show(); // bring up the requested view
				reset();

				// Call startTimeline to create the timeline. Would prefer to have
				// an already instantiated timeline object, but immediateRender:false
				// does not work, thereby starting rendering once the object is created.
				startTimeline()
					.add(function () {
							$(currentView.el).hide(); // hide old view
							currentView = views[id]; // update currentView 
						})
					.timeScale(this.transitionSpeed);
					
			}

		}
	};
}());
